%Quantization (roundoff) utilities: Roundoff Toolbox
%Version 2.0
%ROUNDOFF_DATE  Display date of last modification
%
%BIN2NUM  Convert binary string to Matlab double precision number
%CMULQ    Complex multiplication with quantization after terms to be added
%FILTER_DIRII_Q  Filter, direct II, quantized
%LATCFILT_AP_Q  Lattice allpass filter, quantized
%LSB      Least significant bit (LSB) value in a number
%NEXTAFTER  The next representable neighbor of x in the direction toward y
%NUM2SIGEXP  Illustrate a floating-point number
%NUM2BIN  Illustrate contents of floating-point number in binary string
%QSTRUCT  Make a quantizer (a special structure)
%QSTRUCTCMP  Compare properties of two quantizers
%QSTRUCTGET  Get properties of quantizer
%QSTRUCTSET  Set properties of quantizer
%ROUNDFLOAT  Round floating-point numbers, with convergent rounding for fraction = 0.5
%ROUNDCONV  Round numbers, with convergent rounding for fraction = 0.5
%ROUNDDFT  Rounded calculation of DFT. 
%ROUNDIDFT  Rounded calculation of IDFT. 
%ROUNDFFT  Rounded calculation of FFT. For non-power-of-2, chirp FFT is used. 
%ROUNDIFFT  Rounded calculation of IFFT. For non-power-of-2, chirp FFT is used. 
%ROUNDRAND  Round numbers, with probability (0.5/0.5) rounding for fraction = 0.5
%ROUNDQ  Fixed-point or floating-point roundoff
%ULP Unit in the last place for floating-point quantization with precision p
%RES2TF  Convert tf filter description to resonators
%RESFILTQ  Filter signal with resonators
%TF2RES  Convert resonator filter description to tf
%
%CDF_GAUSS  Gaussian CDF function and integrals of x*f(x), x^2*f(x)
%COMPRESS  Compressor for floating point quantization
%EXPAND  Expander for floating point quantization
%QMOMENTS  Calculate errors of moments of quantized variables from CF

%TESTROUNDOFF  Test all quantization function M-files

% Copyright (c) I. Kollar, 1991-2008
% All rights reserved.