function [x1x2,ovfind]=cmulq(x1,x2,Qmul,Q)
%CMULQ    Complex multiplication with quantization after terms to be added
%
%       [x1x2,ovfnd]=cmulq(x1,x2,Q)

%	Copyright (c) I. Kollar, 2005-2008, all rights reserved
%	Last modified: 20-Jul-2008

ovfind=[];
if nargin<3, Qmul=''; end
if nargin<4, Q=''; end

if (real(x1)==0)|(imag(x1)==0)|(real(x2)==0)|(imag(x2)==0)
  [x1x2,ovfind]=roundq(x1*x2,Q,'complex');
else
  x1x2=roundq(real(x1)*real(x2),Qmul)-roundq(imag(x1)*imag(x2),Qmul)+...
    j*(roundq(real(x1)*imag(x2),Qmul)+roundq(imag(x1)*real(x2),Qmul));
  if (~isempty(Q)&strncmp(Q.Type,'fl',2))|isempty(Qmul)|...
      (~isempty(Qmul)&~isempty(Q)&strncmp(Q.Type,'fi',2)&strncmp(Qmul.Type,'fi',2)&(Q.Bits<Qmul.Bits))
    [x1x2,ovfind]=roundq(x1x2,Q);
  else
    q=lsb(x1x2,Q);
    if isstruct(Q)
      if strncmp(Q.Type,'fixed',2)&...
          any([real(x1x2),imag(x1x2)]>Q.Maximum+q/2)|any([real(x1x2),imag(x1x2)]<Q.Minimum-q/2)
        [x1x2,ovfind]=roundq(x1x2,Q);
      end
    end
  end
end
return
%
%End of cmulq