function cfpars
%Definitions of the pdf-s and parameters:
%
%	Chi-squared: ampl=sigma, arg2=n,
%   f(x) = 1/sigma * ((x/sigma)^((n-2)/2)*exp(-(x/sigma)/(2)) / (2^(n/2)*gamma(n/2))
%        x>=0, sigma>0
%	exponential: ampl=lambda,
%	  f(x) = lambda*exp(-lambda*x), x>=0, lambda>0
%	gamma: ampl=lambda, arg2=alpha,
%	  f(x) = lambda*(lambda*x)^(alpha-1)*exp(-lambda*x) / gamma(alpha)
%        x>0, alpha>0, lambda>0
%	Gaussian: ampl=sigma,
%	  f(x) = 1/(sqrt(2*pi)*sigma)*exp(-(x)^2/(2*sigma^2)), sigma>0
%	Laplacian: ampl=alpha,
%	  f(x) = alpha/2*exp(-alpha*abs(x)), alpha>0
%	Rayleigh: ampl=alpha
%	  f(x) = x/alpha^2*exp(-x^2/(2*alpha^2)), alpha>0, x>=0
%	sinusoidal: ampl=A,
%	  f(x) = 1/(A*pi*sqrt(1-(x/A)^2)) , abs(x)<A, A>0
%	triangular: ampl=A,
%	  f(x) = 1/A*(1-abs(x)/A), abs(x)<A, A>0
%	uniform: ampl=A,
%   f(x) = 1/(2*A), abs(x)<A, A>0
%	binary: ampl=A,
%   f(x) = 0.5*delta(x-A) + 0.5*delta(x+A)
