function []=dither_bar(M);
%dither_bar

% Last modified: 29-Oct-2006 

if nargin<1, M=[]; end, if isempty(M), M=100; end
tods = {'u1' 'u2' 'u3' 't1' 't2' 't3'};
Qtest=qstruct('Name','Qtest','B',8,'fb',4,'dither','on','tod','u1','Sequenceperm','disabled');
sequenceperms={'disabled' 'enabled'};
Qtest.Other

fig=0;
for kk=1:length(sequenceperms)
  Qtest=qstructset(Qtest,'Sequenceperm',sequenceperms{kk});
  for ii=1:length(tods)
    fig=fig+1;
    fprintf('\nType of dither: %s\n',tods{ii})
    Qtest=qstructset(Qtest,'tod',tods{ii});
    if strcmpi(sequenceperms{kk},'enabled')
      M = Qtest.Other.SumHmtimes;
    end
    fprintf('Theoretical sequence length: %.0f, number of samples: %.0f\n',Qtest.Other.SumHmtimes,M)
    for jj=1:M
      szam = roundq(1.3,Qtest);
      if rem(jj,100)==0, fprintf('.'), end
      if rem(jj,50*100)==0, fprintf('\n'), end
    end
    disp(' ')
    figure(fig); clf
    bar(Qtest.Other.Sdith,Qtest.Other.NumberOfUsage,0.5,'c');
    hold on;
    plot(Qtest.Other.Sdith,Qtest.Other.Hmtimes./Qtest.Other.SumHmtimes*M,'rh');
    title(['Type of dither: ',tods{ii},',    Sequenceperm = ',sequenceperms{kk}]);
    xlabel(' x lsb');
    hold off; shg
    if ii<length(tods)
      fprintf('Press any key to continue ... ')
      pause, disp(' ')
    end
  end
end