%FFT_COMPARISON with Matlab's fft, with and without dither, fixed-point

clear;
close all;

f = 100;

Q16_d_off = qstruct('Name','Q16_d_off','B',16,'fb',14)
qstructget(Q16_d_off)

Q16_d_u1 = qstruct('Name','Q16_d_u1','B',16,'fb',14,'dither','on','tod','u1')
qstructget(Q16_d_u1)

tt = 1;
for i=0:0.0001:0.0256-0.0001
  t1(tt)=i;
  tt=tt+1;
end

for i=1:length(t1)
  x1(i)=sin(2*pi*f*t1(i))+0.5*sin(2*pi*2*f*t1(i))+0.3*sin(2*pi*3*f*t1(i)) - 0.1 + (0.1-(-0.1)).*rand(1,1);
end

figure;
plot(t1,x1,'x');
title('Az eredeti jel');

figure
X=fft(x1);
plot(abs(X)); shg
title('A Matlab fft-je');


%  x1 jelre

algorithm = {'dit','dif'};

Q = {Q16_d_off,Q16_d_u1};

for q = 1:length(Q)
  for e = 1:2
    clear runmod;
    if (e == 1)
      runmod.exponent = 'block-float';
    end
    for k=1:length(algorithm)
      runmod.algorithm = algorithm(k);
      if (exist('X1_roundfft','var')) clear X1_roundfft; end
      X1_roundfft=roundfft(x1,Q{q},runmod);
      if (e == 1)
        figure;
        plot(abs(X1_roundfft.data));
        title([Q{q}.Name ' , ' algorithm{k} ' , ' runmod.exponent]);
      else
        figure;
        plot(abs(X1_roundfft));
        title([Q{q}.Name ' , ' algorithm{k} ' , non block-float']);
      end
    end
  end
end
save
