%FFT_COMPARISON_FLOAT with Matlab's fft, with and without dither, floating-point
%
%    The main goal of this function is to compare the following two 
%    FFT algorithms using different quantizers (floating-point / fix-point, 
%    dither: on/off):
%
%    fft(), 
%    roundfft() using runmod.algorithm = 'DIT'
%    
%   The input vector contains samples of a noiseless sinus function with
%   changing frequency.

clear;
close all;

Qfloat_d_off = qstruct('Name','Qfloat_d_off','p','2')
qstructget(Qfloat_d_off)

Qfloat_d_u1 = qstructset(Qfloat_d_off,'Name','Qfloat_d_u1','dither','on','tod','u1')
qstructget(Qfloat_d_u1)


M = 3:0.1:3.9;
N = 256;
t = 0:0.001:0.256-0.001;
fs = 1/0.001;
f = M./N*fs;
fperfs = f./fs;
fig = 1;

jelek = [];
argf = 2*pi.*f;
for ff=1:length(f)
    for tt=1:length(t)
        argft(tt)=argf(ff)*t(tt);
    end
    [x]=sin(argft);
    jelek = [jelek ; x];
end

sizejelek=size(jelek);
% 
% for sj1=1:sizejelek(1)
% figure(fig);
% fig = fig +1;
% plot(t,jelek(sj1,:),'x');
% tit=['Az eredeti jel, f =  ',int2str(f(sj1))];
% title(tit);
% end

X_FFT=[];
for sj1=1:sizejelek(1)
% figure(fig);
% fig = fig +1;
X=fft(jelek(sj1,:));
X_FFT=[X_FFT; X];
% plot(abs(X_FFT(sj1,:)),'h');
% title(['A Matlab fft-je a(z) ' int2str(sj1) '. jelre']);
end

%  Mindegyik jelre

algorithm = {'dit'};

Q = {Qfloat_d_off,Qfloat_d_u1};

ossz_esetszam = sizejelek(1)*length(Q)*length(algorithm);
eset = 1;
for sj1=1:sizejelek(1)
for q = 1:length(Q)
   clear runmod;
   for k=1:length(algorithm)
      runmod.algorithm = algorithm(k);
      if (exist('X_roundfft','var')) clear X_roundfft; end
      x=jelek(sj1,:);
      X_roundfft=roundfft(x,Q{q},runmod);
      X_ROUNDFFT = X_roundfft;
%        figure(fig);
%        fig = fig + 1;
%        plot(abs(X_ROUNDFFT),'h'); 
%        title([int2str(sj1) '.jelalak, ' Q{q}.Name]);
      
      % X_DIFF = (Matlab fft-je)-(a roundfft fft-je), ez mg komplex:
      X_DIFF =  X_FFT(sj1,:)-X_ROUNDFFT;
      
      % ABS_X_DIFF = abs(X_DIFF), ez mr vals, ez a hiba rdekel minket
      ABS_X_DIFF = abs(X_DIFF);
      
      ABS_X_DIFF_FLOAT(eset,:) = abs(X_DIFF);
      
      ABS_X_ROUNDFFT = abs(X_ROUNDFFT);
      SUM_ABS_X_FFT = sum(abs(X_FFT(sj1,:)));
      SUM_ABS_X_ROUNDFFT = sum(abs(X_ROUNDFFT));
      MAX_ABS_X_FFT = max(abs(X_FFT(sj1,:)));
      MAX_ABS_X_ROUNDFFT = max(abs(X_ROUNDFFT));
%        figure(fig);
%        fig = fig + 1;
%        plot(ABS_X_DIFF,'p'); 
%        title(['Az eltrs a Matlab fft-jtl a(z) ' int2str(sj1) '.jelalak esetn, ' Q{q}.Name]);
      disp([int2str(sj1) '.jelalak' ' a(z) ' int2str(sizejelek(1)) ' kzl , kvantl: ' Q{q}.Name ' , algorithm: ' algorithm{k}]);
      disp([int2str(eset) '. eset a(z) ' int2str(ossz_esetszam) ' eset kzl...']);
      tortresz = rem(M(sj1),1);
      egeszresz = M(sj1)-tortresz;
      tort_string = num2str(tortresz);
      egesz_string = num2str(egeszresz);
      disp(['Saving ' Q{q}.Name '_' egesz_string 'M' tort_string(3:end) '_' int2str(N)  'N_' algorithm{k} '.mat' ' ...']);
      save([Q{q}.Name '_' egesz_string 'M' tort_string(3:end) '_' int2str(N)  'N_' algorithm{k} '.mat']);
      load_command = [Q{q}.Name '_' egesz_string 'M' tort_string(3:end) '_' int2str(N)  'N_' algorithm{k} '=load(''' Q{q}.Name '_' egesz_string 'M' tort_string(3:end) '_' int2str(N)  'N_' algorithm{k} '.mat'');'];
      evalin('base',load_command);
      eset = eset+1;
   end
end
end

save('fft_comparison_float_results.mat')