%HG_EXAMPLES
%
%   Examples from dissertation of G. Horvath, Dr.
%
%

close all;

% % PDP11 F  szmbrzolsi forma --> ld. http://www.quadibloc.com/comp/cp0201.htm
% PDP11_F = qstruct('Name','PDP11_F','type','floating-point','LeadingBit','h','Precision',24,'Emax',128,'Emin',-127);
% qstructget(PDP11_F)
% 
% % PDP11 D  szmbrzolsi forma --> ld. http://www.quadibloc.com/comp/cp0201.htm
%  PDP11_D = qstruct('Name','PDP11_D','type','floating-point','LeadingBit','h','Precision',53,'Emax',128,'Emin',-127);
%  qstructget(PDP11_D)

% Double
QSINGLE = qstruct('single','Name','QSINGLE');
qstructget(QSINGLE)
PDP11_F = QSINGLE;

% Single
 QDOUBLE = qstruct('double','Name','QDOUBLE');
 qstructget(QDOUBLE)
 PDP11_D = QDOUBLE;

% 4 bites, fix-pontos kvantl, dither = off
BIT4_d_off = qstruct('Name','BIT4_d_off','type','fixed-point','B',4,'fb',0);
qstructget(BIT4_d_off)

% % 4 bites, fix-pontos kvantl, dither = u3
BIT4_d_u3 = qstructset(BIT4_d_off,'Name','BIT4_d_u1','Dither','on','ToD','u3','L',8)
qstructget(BIT4_d_u3)

clear x1;
clear t1;
fig = 1;

f = 100;
fs = 800;
tt = 1;
A=7;
N=512;
 for i=0:1/fs:1/fs*N-1/fs
     t1(tt)=i;
     tt=tt+1;
 end
 
 for i=1:length(t1)
    arg(i)=2*pi*f*t1(i);
    x1(i)=A*sin(arg(i));
 end
 
 figure(fig);
 fig = fig + 1;
 plot(t1,x1,'x');
 title('A 100 Hz-es szinuszjel');
 
 %%  x1 jelre, "gpi" (PDP11_F) fft:
  
 figure(fig);
 fig = fig + 1;
 X1_FFT_PDP11_F = roundfft(x1,PDP11_F);
 plot(20*log10(abs(X1_FFT_PDP11_F)),'x');
 title('PDP11 F szmbrzols');
 ylabel('dB');  
 %%  x1 jelre, "gpi" (PDP11_D) fft:
   
 X1_FFT_PDP11_D = roundfft(x1,PDP11_D);
 figure(fig);
 fig = fig + 1;
 plot(20*log10(abs(X1_FFT_PDP11_D)),'x');
 title('PDP11 D szmbrzols');
 ylabel('dB'); 
 
 
 for hanyszor = 1:100
 disp(['1. ciklus, ' num2str(hanyszor) '. eset ']);
  % FFT: 4 bites fixpontos aritmetika, dither nlkl:
  
 runmod.exponent = 'block-float';
 
 X1_FFT_BIT4_d_off_results = roundfft(x1,BIT4_d_off,runmod);
 X1_FFT_BIT4_d_off(hanyszor,:)=X1_FFT_BIT4_d_off_results.data*X1_FFT_BIT4_d_off_results.bfe;
%  figure(fig);
%  fig = fig + 1;
%  plot(20*log10(abs(X1_FFT_BIT4_d_off.data.*X1_FFT_BIT4_d_off.bfe)),'x');
%  title('FFT: 4 bites fixpontos aritmetika, dither nlkl');
%  ylabel('dB'); 
 
 % FFT: 4 bites fixpontos aritmetika, ditherrel:
 X1_FFT_BIT4_d_u3_results = roundfft(x1,BIT4_d_u3,runmod);
 X1_FFT_BIT4_d_u3(hanyszor,:) = X1_FFT_BIT4_d_u3_results.data*X1_FFT_BIT4_d_u3_results.bfe;
 
%  figure(fig);
%  fig = fig + 1;
%  plot(20*log10(abs(X1_FFT_BIT4_d_u1.data.*X1_FFT_BIT4_d_u1.bfe)),'x');
%  title('FFT: 4 bites fixpontos aritmetika, ditherrel');
%  ylabel('dB');
 filename = ['hg_examples_results_double' num2str(A) 'A_' num2str(BIT4_d_u3.FractionBits) 'fb_' num2str(BIT4_d_u3.Number_of_DitherBits) 'L.mat'];
 save(filename);
 end
 
 for n=1:N
     osszeg_X1_FFT_BIT4_d_off(n)=sum(X1_FFT_BIT4_d_off(1:end,n));
     osszeg_X1_FFT_BIT4_d_u3(n)=sum(X1_FFT_BIT4_d_u3(1:end,n));
 end
 
  figure(fig);
  fig = fig + 1;
  plot(20*log10(abs(osszeg_X1_FFT_BIT4_d_off)/hanyszor),'h');
  title(['FFT: 4 bites fixpontos aritmetika, dither nlkl, ' num2str(hanyszor) ' futs tlaga']);
  ylabel('dB'); 
  
  figure(fig);
  fig = fig + 1;
  plot(20*log10(abs(osszeg_X1_FFT_BIT4_d_u3)/hanyszor),'h');
  title(['FFT: 4 bites fixpontos aritmetika, ditherrel, ' num2str(hanyszor) ' futs tlaga']);
  ylabel('dB');
  
  save(filename);
  