%TESTPQN  Test the use of PQN

Qs=qstruct('single','name','Single')
QsPQN=qstruct('single','Operation','PQN','name','Single-PQN')
QfixPQN=qstruct('16-bit','Operation','PQN','name','16-bit-PQN')
Qfix=qstruct('16-bit','name','16-bit')

if ~isequal(lsb(1,Qs),2^(-23)), error('lsb is wrong'), end
if ~isequal(lsb(1,QsPQN),2^(-23)), error('lsb is wrong'), end
if ~isequal(lsb(1,Qfix),1), error('lsb is wrong'), end
if ~isequal(lsb(1,QfixPQN),1), error('lsb is wrong'), end
if ~isequal(lsb(1-2^(-23),Qs),2^(-24)), error('lsb is wrong'), end
if ~isequal(lsb(1-2^(-23),QsPQN),2^(-24)), error('lsb is wrong'), end

big=0; ic=0;
for Q={Qs,QsPQN,QsPQN,Qfix,QfixPQN,QfixPQN}
  ic=ic+1;
  Q=Q{1}; str=''; if any(ic==[3,6]), str=', quantized input'; end
  disp(['Quantizer: ',Q.Name,str])
  N=2e2;
  for ii=1:N
    x=100*randn; while (ic<4)&(abs(x)<pow2(-127)), x=100*randn; end
    if ic==3, x=roundq(x,Qs);
    elseif ic==6, x=roundq(x,Qfix);
    end
    xq=roundq(x,Q);
    q=lsb(xq,Q); 
    if ic<4 %float
      if (abs(xq-x)>0.4*q)&any(ic==[2,3]), big=big+1; end
      if abs(xq-x)>0.5*q, error('Too large PQN'), end
    else %fix
      if (abs(xq-x)>0.4*q)&any(ic==[5,6]), big=big+1; end
      if abs(xq-x)>0.5*q, error('Too large PQN'), end
    end
  end
end
percent_20=big/(4*N), pause(10)
