function x=roundidft(X,Q,runmod)
%ROUNDIDFT Quantized IDFT algorithm
%
%   x=roundidft(X,Q)
%
%   Input arguments:
%     X = input sequence (2's power)
%     Q = definition of the quantizer (if not given, IEEE double)
%     runmod = run modifiers (see rounddft)
%   Output arguments:
%     x = vector, or structure for block-float 
%          fields for block-float: data, bfe
%
%   Example:
%     roundidft(rounddft([1:8]))

%	Copyright (c) I. Kollar, 2006, all rights reserved
%	Last modified: 01-Nov-2006

if nargin<3, runmod=struct('direction','inverse'); 
else runmod.direction='inverse'; 
end
if nargin<2, Q='double'; end, if isempty(Q), Q='double'; end
x=rounddft(X,Q,runmod);
%