function xprime=roundrand(x)
%ROUNDRAND Fixed-point roundoff of numbers, with probability (0.5/0.5) rounding for fraction = 0.5
%
%   Examples:
%     roundrand([-5.5:5.5]) %random integer values at distance 0.5

%	Copyright (c) I. Kollar, 2006, all rights reserved
%	Last modified: 1-May-2006

if any(imag(x(:))), x=real(x); xi=imag(x); else xi=[]; end
ind=find(abs(abs(rem(x,1))-0.5)<1e5*eps);
if ~isempty(ind), x(ind)=x(ind)+0.49*(rand(size(ind))-0.5); end
xprime=round(x);
if ~isempty(xi)
  ind=find(abs(abs(rem(xi,1))-0.5)<1e5*eps);
  if ~isempty(ind), xi(ind)=xi(ind)+0.49*(rand(size(ind))-0.5); end
  xprimei=round(xi);
  xprime=xprime+j*xprimei;
end
%
%End of roundrand